﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Net;
using System.Xml.Serialization;
using System.IO;

namespace FLY.FeedbackRenZiJia.UI.Client
{
    //代替TDInitParam
    public class SysParam : Misc.ISaveToXml, INotifyPropertyChanged
    {
        static SysParam current;
        public static SysParam Current 
        {
            get {
                if (current == null)
                {
                    current = new SysParam();
                }
                return current;
            }
        }
        
        #region 属性，成员变量的代理
        private IPEndPoint serverep;
        public IPEndPoint ServerEP {
            get { return serverep; }
            set {
                if (serverep != value)
                {
                    serverep = value;
                    NotifyProperty("ServerEP");
                }
            }
        }

        private IPEndPoint thickep;
        public IPEndPoint ThickEP
        {
            get { return thickep; }
            set
            {
                if (thickep != value)
                {
                    thickep = value;
                    NotifyProperty("ThickEP");
                }
            }
        }

        private double positionx=0;
        public double PositionX
        {
            get { return positionx; }
            set
            {
                if (positionx != value)
                {
                    positionx = value;
                    NotifyProperty("PositionX");
                }
            }
        }
        private double positionwidth = 100;
        public double PositionWidth
        {
            get { return positionwidth; }
            set
            {
                if (positionwidth != value)
                {
                    positionwidth = value;
                    NotifyProperty("PositionWidth");
                }
            }
        }
        private double innerplotpositionx=5;

        public double InnerPlotPositionX
        {
            get { return innerplotpositionx; }
            set
            {
                if (innerplotpositionx != value)
                {
                    innerplotpositionx = value;
                    NotifyProperty("InnerPlotPositionX");
                }
            }
        }
        private double innerplotpositiony=5;

        public double InnerPlotPositionY
        {
            get { return innerplotpositiony; }
            set
            {
                if (innerplotpositiony != value)
                {
                    innerplotpositiony = value;
                    NotifyProperty("InnerPlotPositionY");
                }
            }
        }
        private double innerplotpositionwidth = 90;

        public double InnerPlotPositionWidth
        {
            get { return innerplotpositionwidth; }
            set
            {
                if (innerplotpositionwidth != value)
                {
                    innerplotpositionwidth = value;
                    NotifyProperty("InnerPlotPositionWidth");
                }
            }
        }

        private double innerplotpositionheight=80;
        public double InnerPlotPositionHeight
        {
            get { return innerplotpositionheight; }
            set
            {
                if (innerplotpositionheight != value)
                {
                    innerplotpositionheight = value;
                    NotifyProperty("InnerPlotPositionHeight");
                }
            }
        }

        private bool isHideStable = false;
        /// <summary>
        /// 主界面隐藏稳定状态
        /// </summary>
        public bool IsHideStable 
        {
            get { return isHideStable; }
            set {
                if (isHideStable != value) 
                {
                    isHideStable = value;
                    NotifyProperty("IsHideStable");
                }
            }
        }

        public string Path = "feedbackrenzijiaparam.xml";
        #endregion
        public SysParam() 
        {
            ServerEP = Misc.StringConverter.ToIPEndPoint("127.0.0.1:20007");
            ThickEP = Misc.StringConverter.ToIPEndPoint("127.0.0.1:20006");
            if (!Load())
                Save();
        }



        public bool Load()
        {
            return Misc.SaveToXmlHepler.Load(Path,this);
        }
        public void Save()
        {
            Misc.SaveToXmlHepler.Save(Path, this);
        }


        public string[] GetSavePropertyNames()
        {
            return new string[]{
                "ServerEP",
                "ThickEP",
                "PositionX",
                "PositionWidth",
                "InnerPlotPositionX",
                "InnerPlotPositionY",
                "InnerPlotPositionWidth",
                "InnerPlotPositionHeight",
                "IsHideStable"
            };
        }
        protected void NotifyProperty(string propertyname) 
        {
            if (PropertyChanged != null)
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyname));
        }
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
