﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace FLY.FeedbackRenZiJia.Server
{

    public interface IPLCLink:INotifyPropertyChanged
    {
        #region 输出
        /// <summary>
        /// 加热通道数
        /// </summary>
        UInt16 ChannelCnt { get; set; }
        /// <summary>
        /// 加热量更新
        /// </summary>
        UInt16 HeatUpdate { get; set; }
        /// <summary>
        /// 设置加热量
        /// </summary>
        /// <param name="idx"></param>
        /// <param name="value"></param>
        void SetHeat(int idx, UInt16 value);

        
        #endregion

        #region 当前值
        /// <summary>
        /// 当前电流 有没？
        /// </summary>
        bool HasElectricity { get; }
        /// <summary>
        /// 风机是否启动？
        /// </summary>
        bool HasFan { get; }
        /// <summary>
        /// 当前值更新
        /// </summary>
        UInt16 CurrUpdate { get; }
        /// <summary>
        /// 获取当前值
        /// </summary>
        /// <param name="idx"></param>
        /// <returns></returns>
        UInt16 GetCurr(int idx);
        #endregion

        #region 状态
        int Errno { get; set; }
        int RetCode { get; set; }
        #endregion

    }
}
