﻿using FLY.FeedbackRenZiJia.OBJ_INTERFACE;
using FLY.OBJComponents.Server.OBJProxy;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;

namespace FLY.FeedbackRenZiJia.Server.OBJProxy
{
    public class OBJProxy
    {
        OBJ_FileBus.Server_OBJProxy mServerOBJProxy;
        FLY.Thick.RemoteHistory.RemoteHistory_OBJProxy mRemoteHistoryOBJProxy;
        FeedbackHeat_OBJProxy mFeedbackOBJProxy;
        HeatBuf_OBJProxy mBufOBJProxy;
        HeatCell_OBJProxy mCellOBJProxy;
        SnapShotBuf_OBJProxy mSnapShotOBJProxy;
        WarningSystem_OBJProxy mWarnSystemOBJProxy;

        public OBJProxy(int objsys_idx, TDGage gage)
        {
            TDGage mGage = gage;
            mServerOBJProxy = new OBJ_FileBus.Server_OBJProxy(objsys_idx, mGage.mServer);
            mRemoteHistoryOBJProxy = new FLY.Thick.RemoteHistory.RemoteHistory_OBJProxy(objsys_idx,
                OBJ_INTERFACE_ID.REMOTEHISTORY_ID, mGage.mfeedback.mHeatBuf.mHistory);

            mFeedbackOBJProxy = new FeedbackHeat_OBJProxy(objsys_idx, mGage.mfeedback);
            mBufOBJProxy = new HeatBuf_OBJProxy(objsys_idx, mGage.mfeedback.mHeatBuf);
            mCellOBJProxy = new HeatCell_OBJProxy(objsys_idx, mGage.mfeedback.mHeatCell);
            mSnapShotOBJProxy = new SnapShotBuf_OBJProxy(objsys_idx, mGage.mfeedback.mSnapShotBuf);
            mWarnSystemOBJProxy = new WarningSystem_OBJProxy(objsys_idx, OBJ_INTERFACE.OBJ_INTERFACE_ID.WARNING_OBJ_ID, mGage.mfeedback.mWarning);
            mFeedbackOBJProxy.CurrObjSys.Start_Conn_Server(
                new IPEndPoint(IPAddress.Any, gage.OBJ_Port),
                mServerOBJProxy.ID);
        }
    }
}
