﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;

namespace Misc
{
    public static class PropertiesManager
    {

        /// <summary>
        /// 获取所有属性名。
        /// </summary>
        /// <returns></returns>
        public static IEnumerable<string> GetAllPropertyNames(object obj)
        {
            PropertyInfo[] properties = obj.GetType().GetProperties();

            return from p in properties select p.Name;
        }

        /// <summary>
        /// 设定参数（属性）的值，触发属性值变化“通知”,writeVal
        /// </summary>
        /// <param name="propertyName">属性名</param>
        /// <param name="val">属性值</param>
        public static void SetValue(object obj, string propertyName, object v)
        {
            PropertyInfo property = obj.GetType().GetProperties().First(p => { return p.Name == propertyName; });
            if (property != null)
            {
                property.SetValue(obj, v, null);
            }
        }

        /// <summary>
        /// 设定参数（属性）的值，触发属性值变化“通知”,writeVal
        /// </summary>
        /// <param name="pname">属性名</param>
        /// <param name="val">属性值</param>
        public static void SetValue(object obj, string propertyName, string val)
        {
            PropertyInfo property = obj.GetType().GetProperties().First(p => { return p.Name == propertyName; });
            if (property != null)
            {
                object v = Converter.Parse(val, property.PropertyType);
                property.SetValue(obj, v, null);
            }
        }

        /// <summary>
        /// 获取设定的属性值，writeVal
        /// </summary>
        /// <param name="pname"></param>
        /// <returns></returns>
        public static object GetValue(object obj, string propertyName)
        {
            PropertyInfo property = obj.GetType().GetProperties().First(p => { return p.Name == propertyName; });
            if (property != null)
            {
                return property.GetValue(obj, null);
            }
            else
                return null;
        }
    }
}
