﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Navigation;
using System.Windows.Media.Animation;

using Misc;

using FLY.Thick.Base.IService;
using FLY.Thick.Base.Client;
using FLY.Thick.Base.Common;
using System.Globalization;
using System.Threading;
using ThickTcpUiInWindow;

namespace FLY.Thick.Blowing.UI.Fix.Client
{
    /// <summary>
    /// Window1.xaml 的交互逻辑
    /// </summary>、
    public partial class MainWindow : NavigationWindow
    {
        #region 延时推送 MARKNO
        const int MARKNO_WARNING_RING = 1;
        #endregion

        TDGage gage;

        public MainWindow()
        {
            InitializeComponent();

            NavigationCommands.BrowseBack.InputGestures.Add(new KeyGesture(Key.Escape));

            //BackupFile.Add("graphcustom.xml", BackupFile.xml_isFileOK);
            //BackupFile.Add("csysparam.xml", BackupFile.xml_isFileOK);
            //BackupFile.CheckResult cr = BackupFile.Check();

            //gage = new TDGage();
            //gage.mSysParam.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(mSysParam_PropertyChanged);
            //FLY.UI.OSK.KeyboardBehavior.Enable = gage.mSysParam.HaveOSK;
            //FLY.UI.OSK.KeyboardBehavior.EnableMouseDown = gage.mSysParam.HaveOSK_mouse;
            //gage.mSysParam.Load();

            //gage.Init2();


            //Application.Current.Properties.Add("Password", gage.mPasswordService);
            //Application.Current.Properties.Add("NavigationService", NavigationService);


            //gage.mWarningService.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(mWarningService_PropertyChanged);


            //FObjBase.PollModule.Current.Start();
        }
        int autoscan_tip_id=-1;
       void mWarningService_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {

            if ((e.PropertyName =="ErrTime")||
                (e.PropertyName == "ErrType")||
                (e.PropertyName == "ErrCode")||
                (e.PropertyName == "ErrDescription"))
            {
                FObjBase.PollModule.Current.Poll_JustOnce(
                    delegate()
                    {
                        if ((gage.mWarningService.ErrType == 0) && (gage.mWarningService.ErrCode == 0))
                        {
                            FLY.ControlLibrary.Window_WarningTip.Stop();
                        }
                        else 
                        {
                            if (gage.mWarningService.Enable)
                            {
                                //报警！！！！！！！！
                                FLY.ControlLibrary.Window_WarningTip.Show(
                                    "报警 类型=" + gage.mWarningService.ErrType.ToString() + " " +
                                    "编码=" + gage.mWarningService.ErrCode.ToString(),
                                    gage.mWarningService.ErrDescription,
                                    TimeSpan.MaxValue,
                                    gage.mSysParam.WarningTipPath,
                                    gage.mWarningService.Quiet
                                    );
                            }
                        }
                    }, this, MARKNO_WARNING_RING);
            }
        }
        void mSysParam_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            SysParam sysparam = sender as SysParam;
            if (e.PropertyName == "HaveOSK")
            {
                FLY.UI.OSK.KeyboardBehavior.Enable = sysparam.HaveOSK;
            }
            else if (e.PropertyName == "HaveOSK_mouse") 
            {
                FLY.UI.OSK.KeyboardBehavior.EnableMouseDown = sysparam.HaveOSK_mouse;
            }
            else if (e.PropertyName == "Language")
            {
                UpdateCulture();
            }
        }

        LoadingProgress lp;
        Page_Main pMain;
        void Init()
        {

            //System.Windows.Application.Current.Dispatcher.Invoke(new Action(() =>
            //{
            //    BackupFile.Add("graphcustom.xml", BackupFile.xml_isFileOK);
            //    BackupFile.Add("csysparam.xml", BackupFile.xml_isFileOK);
            //    BackupFile.CheckResult cr = BackupFile.Check();
            //    lp.Progress += 10;
            //}));
            //System.Threading.Thread.Sleep(10);

            System.Windows.Application.Current.Dispatcher.Invoke(new Action(() =>
            {
                gage = new TDGage();
                gage.mSysParam.Load();
                //gage.mSysParam.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(mSysParam_PropertyChanged);
                FLY.UI.OSK.KeyboardBehavior.Enable = gage.mSysParam.HaveOSK;
                FLY.UI.OSK.KeyboardBehavior.EnableMouseDown = gage.mSysParam.HaveOSK_mouse;
                UpdateCulture();


                gage.Init2();
                lp.Progress += 10;
            }));

            System.Threading.Thread.Sleep(10);
            System.Windows.Application.Current.Dispatcher.Invoke(new Action(() =>
            {
                Application.Current.Properties.Add("Gage", gage);
                Application.Current.Properties.Add("Password", gage.mPasswordService);
                System.Windows.Application.Current.Dispatcher.Invoke(new Action(() =>
                {
                    Application.Current.Properties.Add("NavigationService", NavigationService);
                }));

                gage.mWarningService.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(mWarningService_PropertyChanged);
                lp.Progress += 10;
            }));
            System.Threading.Thread.Sleep(10);

            System.Windows.Application.Current.Dispatcher.Invoke(new Action(() =>
            {
                FObjBase.PollModule.Current.Start();
                lp.Progress += 10;
            }));
            System.Threading.Thread.Sleep(10);

        }
        private void NavigationWindow_Loaded(object sender, RoutedEventArgs e)
        {
            lp = new LoadingProgress();
            Application.Current.Properties.Add("LoadingProgress", lp);

            Page_Loading p = new Page_Loading();
            p.DataContext = lp;

            NavigationService.Navigate(p);


            Thread t1 = new Thread(() =>
            {
                Init();

                System.Windows.Application.Current.Dispatcher.Invoke(new Action(() =>
                {
                    pMain = new Page_Main();
                    lp.Progress += 10;
                }));
                System.Threading.Thread.Sleep(10);

                pMain.Init((TDGage)(Application.Current.Properties["Gage"]));

                System.Windows.Application.Current.Dispatcher.Invoke(new Action(() =>
                {
                    NavigationService.Navigate(pMain);
                    pMain.Loaded += (s, e1) =>
                    {
                        NavigationService.RemoveBackEntry();
                    };
                }));
            });
            t1.Start();
        }
        private void UpdateCulture()
        {
            CultureInfo info;
            if (gage.mSysParam.Language == "en-US")
            {
                info = new CultureInfo(gage.mSysParam.Language);
            }
            else
            {
                info = new CultureInfo("zh-CN");
            }
            if (CultureInfo.CurrentCulture.EnglishName == info.EnglishName)
                return;

            Thread.CurrentThread.CurrentCulture = info;
            Thread.CurrentThread.CurrentUICulture = info;

            ThickTcpUiInWindow.App.UpdateCulture(@"Culture/StringResource.");
            ThickTcpUiInWindow.App.UpdateCulture(@"/ThickTcpUiInWindow;component/Culture/StringResource.");
        }
    }
}
