﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;


using System.Collections.ObjectModel;

using FLY.Thick.Base.Client;
using FLY.Thick.Base.Common;
using FLY.ControlLibrary;
using FLY.Thick.BulkDataModule;
using ThickTcpUiInWindow;
using FLY.Thick.Blowing.Client;
using System.ComponentModel;

namespace FLY.Thick.Blowing.UI.Fix.Client
{
    /// <summary>
    /// Page_Main.xaml 的交互逻辑
    /// </summary>
    public partial class Page_Main : Page, INotifyPropertyChanged
    {
        private ThickTcpUiInWindow.UIModule.FLYLayout mLayout;
        private FLYLayoutManager mManager;

        private bool isInMenuSelect = false;
        public bool IsInMenuSelect
        {
            get { return isInMenuSelect; }
            set {
                if (isInMenuSelect != value)
                {
                    isInMenuSelect = value;
                    NotifyPropertyChanged("IsInMenuSelect");
                }
            }
        }

        TDGage gage;
        public Page_Main()
        {
            InitializeComponent();

            stackpanel_menuselect.DataContext = this;
        }
        public void Init(TDGage gage) 
        {
            LoadingProgress lp = Application.Current.Properties["LoadingProgress"] as LoadingProgress;

            System.Windows.Application.Current.Dispatcher.Invoke(new Action(() =>
            {
                this.gage = gage;            
                stackpanel_dynarea.DataContext = gage.mDynArea;
                stackpanel_button.DataContext = gage.mSysParam;

                Init_Border_Blowing();
                Init_Border_Profile();
                lp.Progress += 10;
            }));
            System.Threading.Thread.Sleep(10);

            System.Windows.Application.Current.Dispatcher.Invoke(new Action(() =>
            {
                mLayout = new ThickTcpUiInWindow.UIModule.FLYLayout();
                grid_layout.DataContext = mLayout;
                mManager = new FLYLayoutManager();
                mManager.myUIModules.Add("scangraph",
                new FLY.UI.Module.UIModuleInfo()
                {
                    UIModule = new ThickTcpUiInWindow.UIModule.UIModule_ScanGraph(),
                    Param = new FLY.UI.Module.UIModuleParam()
                    {
                        IsGraphCompnonent = true
                    }
                });
                mManager.myUIModules.Add("trendgraph",
                    new FLY.UI.Module.UIModuleInfo()
                    {
                        UIModule = new ThickTcpUiInWindow.UIModule.UIModule_TrendGraph(),
                        Param = new FLY.UI.Module.UIModuleParam()
                        {
                            IsGraphCompnonent = true
                        }
                    });
                mManager.myUIModules.Add("fixgraph",
                    new FLY.UI.Module.UIModuleInfo()
                    {
                        UIModule = new ThickTcpUiInWindow.UIModule.UIModule_FixGraph(),
                        Param = new FLY.UI.Module.UIModuleParam()
                        {
                            IsGraphCompnonent = true
                        }
                    });
                mManager.myUIModules.Add("scangraph2", new FLY.UI.Module.UIModuleInfo()
                {
                    UIModule = new UIModule.UIModule_ScanGraph2(),
                    Param = new FLY.UI.Module.UIModuleParam()
                    {
                        IsGraphCompnonent = true
                    }
                });
                mManager.myUIModules.Add("trendgraphcircular", new FLY.UI.Module.UIModuleInfo()
                {
                    UIModule = new UIModule.UIModule_ScanGraphCircular(),
                    Param = new FLY.UI.Module.UIModuleParam()
                    {
                        IsGraphCompnonent = true
                    }
                });
                mManager.Init(
                    tabControl1,
                    stackpanel_dynarea,
                    stackpanel_menu,
                    mLayout);
                lp.Progress += 10;
            }));
            System.Threading.Thread.Sleep(10);

            System.Windows.Application.Current.Dispatcher.Invoke(new Action(() =>
            {
                mManager.LoadModule();
                lp.Progress += 10;
            }));
            System.Threading.Thread.Sleep(10);

            System.Windows.Application.Current.Dispatcher.Invoke(new Action(() =>
            {
                gage.mDynArea.PropertyChanged += (s, e) =>
                {
                    DynArea dynarea = s as DynArea;
                    if (e.PropertyName == "ControllerState")
                    {
                        var st = mLayout.ControllerStates.Find(_st => _st.ControllerState == dynarea.ControllerState.ToString());
                        if (st != null)
                        {
                            if (st.No >= 0 && st.No < this.tabControl1.Items.Count)
                                this.tabControl1.SelectedIndex = st.No;
                        }
                    }
                };
                lp.Progress = 100;
            }));
            System.Threading.Thread.Sleep(10);
        }


        BlowingFixProfileService mProfile;
        void Init_Border_Profile()
        {
            mProfile = new BlowingFixProfileService();

            FObjBase.FObjSys.Current.Connect_to_Another_OBJSys(
                gage.mSysParam.ServerIPEP, mProfile.ID);

            Border_Profile.DataContext = mProfile.Param;
        }

        BlowingFixServiceClient mRenZiJiaService;
        BlowingDetectServiceClient mBDetect;

        

        void Init_Border_Blowing() 
        {
            mRenZiJiaService = new BlowingFixServiceClient();
            mBDetect = new BlowingDetectServiceClient();

            FObjBase.FObjSys.Current.Connect_to_Another_OBJSys(
                gage.mSysParam.ServerIPEP, mRenZiJiaService.ID, mBDetect.ID);

            Border_Blowing.DataContext = mRenZiJiaService;
            border_bDetect.DataContext = mBDetect;
            Border_Width.DataContext = mBDetect;
            
        }

        private void button_sysparam_click(object sender, RoutedEventArgs e)
        {
            if (stackpanel_menu.Children.Count > 0)
            {
                IsInMenuSelect = true;
            }
            else
            {
                button_menu_click(sender, e);
            }
        }
        private void button_backmenu_click(object sender, RoutedEventArgs e)
        {
            IsInMenuSelect = false;
        }
        private void button_menu_click(object sender, RoutedEventArgs e)
        {
            Page_Menu p = new Page_Menu();
            p.Init(gage);
            NavigationService.Navigate(p);
        }
        private void button_profile_click(object sender, RoutedEventArgs e)
        {

            Page_ProfileBlowing p = new Page_ProfileBlowing();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);

        }

        private void Border_AD_Click(object sender, RoutedEventArgs e)
        {

        }

        private void Border_Blowing_Click(object sender, RoutedEventArgs e)
        {
            Page_Blowing p = new Page_Blowing();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }

        private void Border_FlyAD_Click(object sender, RoutedEventArgs e)
        {
            Window_FlyADAccess w = new Window_FlyADAccess();
            w.Init(gage.mSysParam.ServerIPEP);
            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            w.ShowDialog();
        }

        private void Border_IO_Click(object sender, RoutedEventArgs e)
        {
            Window_IOTip w = new Window_IOTip();
            w.ShowDialog();
        }

        private void button_epc_start_click(object sender, RoutedEventArgs e)
        {
            mRenZiJiaService.EPCStart();
        }
        private void button_epc_stop_click(object sender, RoutedEventArgs e)
        {
            mRenZiJiaService.EPCStop();
        }

        private void button_option_click(object sender, RoutedEventArgs e)
        {
            ThickTcpUiInWindow.MainEdit.Page_MainEdit p = new ThickTcpUiInWindow.MainEdit.Page_MainEdit();
            p.Init(mManager);
            NavigationService.Navigate(p);
        }


        protected void NotifyPropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
        public event PropertyChangedEventHandler PropertyChanged;


    }



}
