﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Net;

using FObjBase;
using FLY.Thick.Base.Client;
using FLY.Thick.Base.IService;
using FLY.Thick.Base.Common;
using FLY.Thick.BulkDataModule;

using FLY.Thick.Blowing.Client;
using System.Reflection;

namespace FLY.Thick.Blowing.UI.Fix.Client
{
    public class TDGage : ThickTcpUiInWindow.TDGage
    {
        #region 参数--------------------------------------------------------------------

        #region 本地数据----------------------------------------------------------------
        /// <summary>
        /// 系统参数
        /// </summary>
        //public SysParam mSysParam;

        #endregion
        #region 服务器数据--------------------------------------------------------------
        /// <summary>
        /// 动态数据
        /// </summary>
        public DynArea mDynArea;


        public PasswordService mPasswordService;

        public BlowingFixServiceClient mRenZiJiaService;
        public BlowingDetectServiceClient mBDetect;
        #endregion

        #endregion

        public string Version
        {
            get; set;
        }

        public TDGage()
        {
            Assembly asm = Assembly.GetAssembly(this.GetType());
            AssemblyProductAttribute asmproduct = (AssemblyProductAttribute)Attribute.GetCustomAttribute(asm, typeof(AssemblyProductAttribute));
            Version version = asm.GetName().Version;

            string version_str = string.Format("v{0}.{1}.{2}", version.Major, version.Minor, version.Build);
            string buliddt = System.IO.File.GetLastWriteTime(this.GetType().Assembly.Location).ToString("yyyyMMdd");

            Version = asmproduct.Product + " " + version_str + " at " + buliddt;

            Init1();
        }

        #region Init登陆服务器初始化----------------------------------------------------
        /// <summary>
        /// 第1步, 加载本地数据
        /// </summary>
         void Init1()
        {

            #region 提取保存的数据
            mSysParam = new SysParam();//系统参数
            #endregion

            #region 与服务器同步的数据
            mBulkDataClient = new BulkDataServiceClientAdv(new BulkDataServiceClient());

            mDynAreaService = new DynAreaService();
            mDynArea = mDynAreaService.mDynArea;

            mWarningService = new WarningServiceSimple();

            mTDGageService = new TDGageService();

            mFixService = new FixService();

            mPasswordService = new PasswordService();

            mRenZiJiaService = new BlowingFixServiceClient();
            mBDetect = new BlowingDetectServiceClient();

            #endregion
        }

         TCPCConn conn = null;
        /// <summary>
        /// 第2步, 连接到服务器,初始化参数 。由界面的 【登陆】 按钮触发
        /// </summary>
        public void Init2(IPEndPoint serveripep)
        {

            if(!mSysParam.ServerIPEP.Equals(serveripep))
            {
                mSysParam.ServerIPEP = serveripep;
                mSysParam.Save();
            }
            #region 网络初始化
            UInt32[] objids = new UInt32[]{
                mDynAreaService.ID,
                mWarningService.ID,
                ((BulkDataServiceClient)(mBulkDataClient.bulkdata)).ID,
                mTDGageService.ID,
                mFixService.ID,
                mPasswordService.ID,
                mRenZiJiaService.ID,
                mBDetect.ID
            };

            if (conn != null)
            {
                if (!conn.RemoteEP.Equals(mSysParam.ServerIPEP))
                {
                    //断开之前的连接
                    FObjSys.Current.Disconnect_to_Another_OBJSys(conn.RemoteEP, objids);
                }
            }

            conn = FObjSys.Current.Connect_to_Another_OBJSys(mSysParam.ServerIPEP, objids);

            #endregion
        }
        public void Init2() 
        {
            Init2(mSysParam.ServerIPEP);
        }
        
        #endregion

    }
}
