﻿using FObjBase;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace FLY.Thick.Blowing.IService
{
    /// <summary>
    /// 追边测厚仪
    /// </summary>
    public interface IBlowingFixService : IBlowing
    {
        #region 膜长 计算
        /// <summary>
        /// 膜长查找范围， 以FilmLength为目标值，两边查找，单位m
        /// </summary>
        double FLRange { get; set; }

        /// <summary>
        /// 计算的状态，因为是一个很漫长的过程！！！
        /// </summary>
        string CalState { get; }
        #region 计算结果
        /// <summary>
        /// 最大相似度
        /// </summary>
        double MaxR { get; }
        /// <summary>
        /// 最大相识度对应膜长度,单位m
        /// </summary>
        double MaxRFilmLength { get; }

        #endregion

        #endregion

        #region 温修
        /// <summary>
        /// 追边开始按钮自锁
        /// </summary>
        bool IsBtnSelfHold { get; set; }
        /// <summary>
        /// 追边模式
        /// </summary>
        RenZiJiaFixEPCType EPCType { get; set; }

        /// <summary>
        /// 温修时间，默认2秒
        /// </summary>
        TimeSpan SampleConsume { get; set; }

        /// <summary>
        /// 温修间隔，默认45分钟
        /// </summary>
        TimeSpan SampleInterval { get; set; }

        /// <summary>
        /// 当前温修计时，大于温修间隔就会去温修
        /// </summary>
        TimeSpan SampleTimer { get; }

        /// <summary>
        /// 回到边界后，再等待一段时间，那就肯定找到边界了。 默认5s
        /// </summary>
        TimeSpan BackEdgeWait { get; set; }

        /// <summary>
        /// 采样得到的样品AD
        /// </summary>
        int SampleAD { get; }
        /// <summary>
        /// 追边运行中！
        /// </summary>
        bool EPCIsRunning { get; }

        #endregion

        #region 功能
        /// <summary>
        /// 计算膜长， 当计算成功，MaxRFilmLength 算出结果。
        /// 当需要等待， MaxRFilmLength = -1
        /// </summary>
        void CalFilmLength();

        /// <summary>
        /// 追边开始
        /// </summary>
        void EPCStart();

        /// <summary>
        /// 追边停止
        /// </summary>
        void EPCStop();
        #endregion
    }
    /// <summary>
    /// 温修对位硬件类型
    /// </summary>
    public enum RenZiJiaFixEPCType
    {
        Null,
        EPCA10
    }





}
