﻿using FLY.Thick.Base.OBJ_INTERFACE;
using FLY.Thick.Blowing.Common;
using FLY.Thick.Blowing.IService;
using FLY.Thick.Blowing.OBJ_INTERFACE;
using FObjBase;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FLY.Thick.Blowing.Server.OBJProxy
{
    public class BlowingFixProfile_OBJProxy: FObj
    {
        #region 延时推送 MARKNO
        const int MARKNO_PUSH_PARAMS = 1;
        #endregion

        IBlowingFixProfileService mProfile;

        public BlowingFixProfile_OBJProxy(int objsys_idx, IBlowingFixProfileService profile)
            : base(objsys_idx)
        {
            ID = FLY.Thick.Blowing.OBJ_INTERFACE.OBJ_INTERFACE_ID.BFPROFILE_ID;
            mProfile = profile;
            mProfile.Param.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(mProfile_PropertyChanged);
        }

        void mProfile_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            FObjBase.PollModule.Current.Poll_JustOnce(
                new PollModule.PollHandler(delegate ()
                {
                    byte[] buf;
                    GetValue(null, ID, BLOWINGFIX_PROFILE_OBJ_INTERFACE.GET_PARAMS, out buf);
                    CurrObjSys.PushObjInfoEx(
                        this, BLOWINGFIX_PROFILE_OBJ_INTERFACE.PUSH_PARAMS,
                        buf);
                }), this, MARKNO_PUSH_PARAMS);

        }

        public override void GetValue(IFConn from, uint srcid, ushort memid, out byte[] infodata)
        {
            infodata = null;
            switch (memid)
            {
                case BLOWINGFIX_PROFILE_OBJ_INTERFACE.GET_PARAMS:
                    {
                        infodata = mProfile.Param.ToBytes();
                    }
                    break;
                default:
                    infodata = null;
                    break;
            }
        }
        public override void SetValue(IFConn from, uint srcid, ushort memid, byte[] infodata)
        {
            switch (memid)
            {
                case BLOWINGFIX_PROFILE_OBJ_INTERFACE.SET_PARAMS:
                    {
                        BlowingFixProfileParam p = new BlowingFixProfileParam();
                        if (!p.TryParse(infodata))
                            break;
                        mProfile.Param.TryParse(infodata);
                        mProfile.Apply();
                    }
                    break;
            }
        }
        public override void CallFunction(IFConn from, uint srcid, uint magic, ushort funcid, byte[] infodata)
        {
            switch (funcid)
            {
                case BLOWINGFIX_PROFILE_OBJ_INTERFACE.CALL_GETLIST:
                    {
                        mProfile.GetList(
                            new AsyncCBHandler(delegate (object AsyncState, object retdata)
                            {
                                ConnContext context = (ConnContext)AsyncState;
                                List<string> ss = (List<string>)retdata;
                                Pack_StringList p = new Pack_StringList();
                                p.list = (List<string>)retdata;

                                CurrObjSys.PushCallFunctionEx(
                                    context.from,
                                    context.srcid,
                                    ID,
                                    context.magic,
                                    BLOWINGFIX_PROFILE_OBJ_INTERFACE.CALL_GETLIST,
                                    p.ToBytes());
                            }), new ConnContext(from, srcid, magic));
                    }
                    break;
                case BLOWINGFIX_PROFILE_OBJ_INTERFACE.CALL_DEL:
                    {
                        Pack_String p = new Pack_String();
                        if (!p.TryParse(infodata))
                            return;

                        mProfile.Del(p.data);
                    }
                    break;
                case BLOWINGFIX_PROFILE_OBJ_INTERFACE.CALL_READ:
                    {
                        Pack_String p = new Pack_String();
                        if (!p.TryParse(infodata))
                            return;
                        mProfile.Read(
                            p.data,
                            new AsyncCBHandler(delegate (object AsyncState, object retdata)
                            {
                                ConnContext context = (ConnContext)AsyncState;

                                CurrObjSys.PushCallFunctionEx(
                                    context.from,
                                    context.srcid,
                                    ID,
                                    context.magic,
                                    BLOWINGFIX_PROFILE_OBJ_INTERFACE.CALL_READ,
                                    ((BlowingFixProfileParam)retdata).ToBytes());
                            }), new ConnContext(from, srcid, magic));
                    }
                    break;
            }
        }
    }
}
