﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FLY.Thick.BulkDataModule;
using FLY.Thick.Base.Server.OBJProxy;
using FLY.Thick.Base.OBJ_INTERFACE;

namespace FLY.Thick.Blowing.Server.OBJProxy
{
    public class OBJProxy
    {
        OBJ_FileBus.Server_OBJProxy mServerOBJProxy;
        BulkDataService_OBJProxy mBulkDataOBJProxy;
        Curve_OBJProxy mCurveOBJProxy;
        DynArea_OBJProxy mDynAreaOBJProxy;
        FlyAD_OBJProxy mFlyADOBJProxy;
        FLY.Thick.RemoteHistory.RemoteHistory_OBJProxy mRemoteHistoryOBJProxy;
        Fix_OBJProxy mFixOBJProxy;
        BlowingFixProfile_OBJProxy mProfileOBJProxy;
        WarningSystem_OBJProxy mWarningOBJProxy;
        Password_OBJProxy mPasswordOBJProxy;
        TDGage_OBJProxy mTDGageOBJProxy;
        BlowingFix_OBJProxy mBlowingOBJProxy;
        BlowingDetect_OBJProxy mBDetectOBJProxy;
        public OBJProxy(int objsys_idx, TDGage gage)
        {
            TDGage mGage = gage;
            mServerOBJProxy = new OBJ_FileBus.Server_OBJProxy(objsys_idx, mGage.mServer);
            mBulkDataOBJProxy = new BulkDataService_OBJProxy(objsys_idx, mGage.mBulk);


            mProfileOBJProxy = new BlowingFixProfile_OBJProxy(objsys_idx, mGage.mProfile);

            mCurveOBJProxy = new Curve_OBJProxy(objsys_idx, mGage.mCurve);

            mDynAreaOBJProxy = new DynArea_OBJProxy(objsys_idx, mGage.mDynArea);

            mFlyADOBJProxy = new FlyAD_OBJProxy(objsys_idx, mGage.mFlyAD);

            mRemoteHistoryOBJProxy = new FLY.Thick.RemoteHistory.RemoteHistory_OBJProxy(objsys_idx,
                OBJ_INTERFACE_ID.REMOTEHISTORY_ID, mGage.mHistory);

            mFixOBJProxy = new Fix_OBJProxy(objsys_idx, mGage.mGMFix);

            mWarningOBJProxy = new WarningSystem_OBJProxy(objsys_idx, mGage.mWarning);

            mPasswordOBJProxy = new Password_OBJProxy(objsys_idx, mGage.mPassword);

            mTDGageOBJProxy = new TDGage_OBJProxy(objsys_idx, mGage);

            mBlowingOBJProxy = new BlowingFix_OBJProxy(objsys_idx, mGage.mGMRenZiJiaFix);

            mBDetectOBJProxy = new BlowingDetect_OBJProxy(objsys_idx, mGage.mGMRenZiJiaFix.mPDetect);

            mTDGageOBJProxy.CurrObjSys.Start_Conn_Server(
                mGage.mSysParam.LocalEP,
                mServerOBJProxy.ID,
                mBulkDataOBJProxy.ID);
        }
    }
}
