﻿using FLY.Thick.Blowing.Common;
using FLY.Thick.Blowing.IService;
using FObjBase;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace FLY.Thick.Blowing.Server
{
    public class BlowingFixProfile: IBlowingFixProfileService
    {
        BlowingFixProfileParam param = new BlowingFixProfileParam();
        public BlowingFixProfileParam Param
        {
            get
            {
                return param;
            }
        }
        public BlowingFixProfile()
        {

        }
        public BlowingFixProfile(string path)
        {
            if (path == null)
                Load();
            else
                Load(path);
        }

        public bool Load()
        {
            return Misc.SaveToXmlHepler.Load("profile.xml", this.Param);
        }
        bool Load(string path)
        {
            return Misc.SaveToXmlHepler.Load(path, this.Param);
        }

        bool Save()
        {
            bool ret2 = Misc.SaveToXmlHepler.Save(@"profile.xml", this.Param);
            bool ret1 = Misc.SaveToXmlHepler.Save(@"profile\" + Param.PName + ".xml", this.Param);
            return (ret1 && ret2);
        }

        /// <summary>
        /// 应用 &amp; 保存
        /// </summary>
        public void Apply()
        {
            Save();
        }

        /// <summary>
        /// 获取产品列表, 返回类型为 List&lt;string&gt;
        /// </summary>
        /// <param name="AsyncDelegate"></param>
        /// <param name="AsyncState"></param>
        public void GetList(AsyncCBHandler AsyncDelegate, object AsyncState)
        {
            DirectoryInfo dinfo = new DirectoryInfo(@"profile");
            List<string> filenames = new List<string>();
            if (dinfo.Exists)
            {

                foreach (FileInfo info in dinfo.GetFiles())
                {
                    if (Path.GetExtension(info.Name) == ".xml")
                    {
                        filenames.Add(Path.GetFileNameWithoutExtension(info.Name));
                    }
                }
            }
            AsyncDelegate(AsyncState, filenames);
        }

        /// <summary>
        /// 删除指定产品
        /// </summary>
        /// <param name="productname"></param>
        public void Del(string productname)
        {
            string path = @"profile\" + productname + ".xml";
            if (System.IO.File.Exists(path))
                System.IO.File.Delete(path);

        }

        /// <summary>
        /// 读取指定产品,返回类型为 ProfileParam
        /// </summary>
        /// <param name="productname"></param>
        /// <param name="AsyncDelegate"></param>
        /// <param name="AsyncState"></param>
        public void Read(string productname, AsyncCBHandler AsyncDelegate, object AsyncState)
        {
            BlowingFixProfile p = new BlowingFixProfile();
            p.Load(@"profile\" + productname + ".xml");
            AsyncDelegate(AsyncState, p.Param);
        }
    }
}
