﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FLY.Weight.UI.Client
{
    /// <summary>
    /// Window_Frequency.xaml 的交互逻辑
    /// </summary>
    public partial class Window_Frequency : FLY.ControlLibrary.WindowBigClose,INotifyPropertyChanged
    {
        private double frequencySet = 0;
        public double FrequencySet {
            get {
                return frequencySet;
            }
            set {
                if (frequencySet != value)
                {
                    frequencySet = value;
                    NotifyPropertyChanged("FrequencySet");
                }
            }
        }
        public Window_Frequency()
        {
            InitializeComponent();
            this.DataContext = this;
        }

        private void button_minus_Click(object sender, RoutedEventArgs e)
        {
            if (FrequencySet >= 0.1)
            {
                FrequencySet -= 0.1;
            }
        }

        private void button_plus_Click(object sender, RoutedEventArgs e)
        {
            if(FrequencySet<100)
                FrequencySet += 0.1;
        }

        private void button_ok_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = true;
            this.Close();
        }

        protected void NotifyPropertyChanged(string propertyname)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyname));
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
