﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FLY.Weight.UI.Client
{
    /// <summary>
    /// Window_GraphSet.xaml 的交互逻辑
    /// </summary>
    public partial class Window_GraphSet : FLY.ControlLibrary.WindowBigClose, INotifyPropertyChanged
    {
        

        private int flowinterval = 2;
        /// <summary>
        /// 流量记录周期,单位min
        /// </summary>
        public int FlowInterval
        {
            get
            {
                return flowinterval;
            }
            set
            {
                if (value < 1)
                    value = 1;

                if (flowinterval != value)
                {
                    flowinterval = value;
                    NotifyPropertyChanged("FlowInterval");
                }
            }
        }

        private int flowlistsize = 400;
        /// <summary>
        /// 流量列表长度,单位个
        /// </summary>
        public int FlowListSize
        {
            get
            {
                return flowlistsize;
            }
            set
            {
                if (flowlistsize != value)
                {
                    flowlistsize = value;
                    NotifyPropertyChanged("FlowListSize");
                }
            }
        }

        private int flowsaverows = 200;
        /// <summary>
        /// 流量保存周期,单位个
        /// </summary>
        public int FlowSaveRows
        {
            get
            {
                return flowsaverows;
            }
            set
            {
                if (flowsaverows != value)
                {
                    flowsaverows = value;
                    NotifyPropertyChanged("FlowSaveRows");
                }
            }
        }
        private int xrange;
        public int XRange
        {
            get { return xrange; }
            set
            {
                if (xrange != value)
                {
                    xrange = value;
                    NotifyPropertyChanged("XRange");
                }
            }
        }
        public Window_GraphSet()
        {
            InitializeComponent();
            this.DataContext = this;
        }

        private void button_ok_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = true;
            this.Close();
        }

        protected void NotifyPropertyChanged(string propertyname)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyname));
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
