﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FObjBase;
using FLY.Weight.OBJ_INTERFACE;
using System.Net;
using FLY.Weight.Common;
using FLY.OBJComponents.Server.OBJProxy;
using System.ComponentModel;

namespace FLY.Weight.Server.OBJProxy
{
    public class WeightSystem_OBJProxy : FObj
    {
        WeightSystem data;
        SyncProp_OBJProxy syncProp_OBJProxy;
        PLCProxySystem_OBJProxy plcOS_OBJProxy;
        /// <summary>
        /// 流量
        /// </summary>
        Buffer_OBJProxy<FlyData_Flow> mFlowListOBJProxy;
        /// <summary>
        /// 每次配料记录
        /// </summary>
        Dictionary<WeighterC, Buffer_OBJProxy<FlyData_Mix>> mMixBufferOBJProxy = new Dictionary<WeighterC, Buffer_OBJProxy<FlyData_Mix>>();
        /// <summary>
        /// 下辊时，总配料比例记录
        /// </summary>
        Dictionary<WeighterC, Buffer_OBJProxy<FlyData_Mix>> mRollMixBufferOBJProxy = new Dictionary<WeighterC, Buffer_OBJProxy<FlyData_Mix>>();


        public WeightSystem_OBJProxy(int objsys_idx, WeightSystem data):base(objsys_idx)
        {
            ID = OBJ_INTERFACE.OBJ_INTERFACE.WEIGHTS_OBJ_ID;
            this.data = data;

            //--------------------------------------------------------------
            //属性同步
            Dictionary<string, INotifyPropertyChanged> objnames = new Dictionary<string, INotifyPropertyChanged>();
            objnames.Add(".", data);
            objnames.Add("Accessory", data.Accessory);
            for (int i = 0; i < data.Items.Count(); i++)
                objnames.Add("Items[" + i + "]", data.Items[i]);

            syncProp_OBJProxy = new SyncProp_OBJProxy(
                objsys_idx, ID + 1, objnames);

            plcOS_OBJProxy = new PLCProxySystem_OBJProxy(
                objsys_idx,
                OBJ_INTERFACE.OBJ_INTERFACE.WEIGHTS_OBJ_PLCOS_ID,
                data.PLCos
                );

            mFlowListOBJProxy = new Buffer_OBJProxy<FlyData_Flow>(
                objsys_idx,
                OBJ_INTERFACE.OBJ_INTERFACE.WEIGHTS_OBJ_FLOW_ID,
                data.FlowList);


            for (int i=0;i< data.Items.Count();i++)
            {
                WeighterC w = data.Items[i];
                mMixBufferOBJProxy.Add(
                    w, 
                    new Buffer_OBJProxy<FlyData_Mix>(
                        objsys_idx,
                        OBJ_INTERFACE.OBJ_INTERFACE.WEIGHTS_OBJ_MIX_ID(i),
                        data.MixBuffer[w]));

                mRollMixBufferOBJProxy.Add(
                    w,
                    new Buffer_OBJProxy<FlyData_Mix>(
                        objsys_idx,
                        OBJ_INTERFACE.OBJ_INTERFACE.WEIGHTS_OBJ_ROLLMIX_ID(i),
                        data.RollMixBuffer[w]));
            }
        }
    }
}
