////////////////////////////////////////////////////////////////////////////////
//
// Class Name:  excel_access
// Description: ڶȡExcelĵĳԪַݻǰɫɫ
// Class URI:   https://www.fawdlstty.com/archives/405.html
// Author:      Fawdlstty
// Author URI:  https://www.fawdlstty.com/
// Version:     0.2
// License:     MIT
// Last Update: Jul 04, 2017
//
////////////////////////////////////////////////////////////////////////////////

using DocumentFormat.OpenXml;
using DocumentFormat.OpenXml.Extensions;
using DocumentFormat.OpenXml.Packaging;
using DocumentFormat.OpenXml.Spreadsheet;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Excel_Access
{
    public class excel_access
    {
        private SpreadsheetDocument m_ssDoc = null;
        private WorkbookStylesPart m_styles = null;
        private WorkbookPart m_wbPart = null;
        private List<Sheet> m_sheets = null;
        private Sheet m_sheet = null;
        private WorksheetPart m_wsPart = null;
        private String[] m_colors = null;

        /// <summary>
        /// excelĵ빤
        /// </summary>
        /// <param name="path">ļ·</param>
        /// <param name="sheet"></param>
        public void open_excel(String path, String sheet = "Sheet1")
        {
            m_ssDoc = SpreadsheetDocument.Open(path, false);
            m_styles = SpreadsheetReader.GetWorkbookStyles(m_ssDoc);
            m_wbPart = m_ssDoc.WorkbookPart;
            m_sheets = m_wbPart.Workbook.Descendants<Sheet>().ToList();
            m_sheet = m_wbPart.Workbook.Descendants<Sheet>().FirstOrDefault(c => c.Name == sheet);
            m_wsPart = (WorksheetPart)m_wbPart.GetPartById(m_sheet.Id);

            Colors colors = m_styles.Stylesheet.Colors;
            if (colors != null)
            {
                int count = colors.FirstChild.ChildElements.Count;
                m_colors = new String[count];
                for (int i = 0; i < count; ++i)
                    m_colors[i] = ((Color)colors.FirstChild.ChildElements[i]).Rgb.Value;
            }
            else
            {
                m_colors = new String[] {
                    "00000000", "00FFFFFF", "00FF0000", "0000FF00", "000000FF", "00FFFF00", "00FF00FF", "0000FFFF",
                    "00000000", "00FFFFFF", "00FF0000", "0000FF00", "000000FF", "00FFFF00", "00FF00FF", "0000FFFF",
                    "00800000", "00008000", "00000080", "00808000", "00800080", "00008080", "00C0C0C0", "00808080",
                    "009999FF", "00993366", "00FFFFCC", "00CCFFFF", "00660066", "00FF8080", "000066CC", "00CCCCFF",
                    "00000080", "00FF00FF", "00FFFF00", "0000FFFF", "00800080", "00800000", "00008080", "000000FF",
                    "0000CCFF", "00CCFFFF", "00CCFFCC", "00FFFF99", "0099CCFF", "00FF99CC", "00CC99FF", "00FFCC99",
                    "003366FF", "0033CCCC", "0099CC00", "00FFCC00", "00FF9900", "00FF6600", "00666699", "00969696",
                    "00003366", "00339966", "00003300", "00333300", "00993300", "00993366", "00333399", "00333333"
                };
            }
        }

        /// <summary>
        /// 򿪹
        /// </summary>
        /// <param name="sheet"></param>
        public void open_sheet(String sheet = "Sheet1")
        {
            m_sheet = m_wbPart.Workbook.Descendants<Sheet>().FirstOrDefault(c => c.Name == sheet);
            m_wsPart = (WorksheetPart)m_wbPart.GetPartById(m_sheet.Id);
        }

        /// <summary>
        /// رĵ
        /// </summary>
        public void close()
        {
            m_ssDoc.Close();
            m_ssDoc.Dispose();

            m_ssDoc = null;
            m_styles = null;
            m_wbPart = null;
            m_sheets = null;
            m_sheet = null;
            m_wsPart = null;
        }

        /// <summary>
        /// ȡԪ
        /// </summary>
        /// <param name="pos">λ</param>
        /// <returns>Ԫ</returns>
        public Cell get_item(String pos = "A1")
        {
            return m_wsPart.Worksheet.Descendants<Cell>().Where(c => c.CellReference.Value == pos).FirstOrDefault();
        }

        /// <summary>
        /// ȡԪ
        /// </summary>
        /// <param name="iCol">ڼУ0ʼ</param>
        /// <param name="iLine">ڼУ0ʼ</param>
        /// <returns></returns>
        public Cell get_item(int iCol, int iLine)
        {
            String strCol = "";
            if (iCol < 26)
                strCol = string.Format("{0}{1}",((char)((int)'a' + iCol)), iLine + 1);
            else if (iCol < 26 * 26 + 26)
            {
                iCol -= 26;
                strCol = string.Format("{0}{1}{2}",((char)((int)'a' + iCol / 26)), ((char)((int)'a' + iCol % 26)), iLine + 1);
            }
            return get_item(strCol);
        }

        /// <summary>
        /// ȡԪ
        /// </summary>
        /// <param name="cell">Ԫ</param>
        /// <returns></returns>
        public String get_value(Cell cell)
        {
            string value = cell.InnerText;
            if (cell.DataType != null)
            {
                switch (cell.DataType.Value)
                {
                    case CellValues.SharedString:
                        var stringTable = m_wbPart.GetPartsOfType<SharedStringTablePart>().FirstOrDefault();
                        if (stringTable != null)
                        {
                            value = stringTable.SharedStringTable.ElementAt(int.Parse(value)).InnerText;
                        }
                        break;

                    case CellValues.Boolean:
                        switch (value)
                        {
                            case "0":
                                value = "FALSE";
                                break;
                            default:
                                value = "TRUE";
                                break;
                        }
                        break;
                }
            }
            return value != null ? value : "";
        }

        /// <summary>
        /// Tintǳ仯
        /// </summary>
        /// <param name="iColor">ɫֵȡֵ0-255</param>
        /// <param name="tint">ǳ仯</param>
        /// <returns></returns>
        private int calc_single_tinted_value(int iColor, Double tint)
        {
            if (tint < 0)
                return Convert.ToInt32(iColor * (1.0 + tint));
            else if (tint > 0)
                return Convert.ToInt32(iColor * (1.0 - tint) + (255 - 255 * (1.0 - tint)));
            if (iColor < 0 || iColor > 255)
                throw new Exception("tintΧ");
            return iColor;
        }

        /// <summary>
        /// ȡ׼ʽɫַ
        /// </summary>
        /// <param name="ct">ɫ</param>
        /// <returns>׼ʽɫַ</returns>
        private String format_color(ColorType ct)
        {
            if (ct == null)
                return "";

            // ȡɫ
            String strColor = "";
            if (ct.Rgb != null)
            {
                strColor = ct.Rgb.Value;
            }
            else if (ct.Theme != null)
            {
                DocumentFormat.OpenXml.Drawing.Color2Type c2t = (DocumentFormat.OpenXml.Drawing.Color2Type)m_ssDoc.WorkbookPart.ThemePart.Theme.ThemeElements.ColorScheme.ChildElements[(int)ct.Theme.Value];
                //Debug.WriteLine (c2t.OuterXml);
                if (c2t.RgbColorModelHex != null)
                    strColor = c2t.RgbColorModelHex.Val;
            }
            else if (ct.Indexed != null)
            {
                int iIndexed = (int)(uint)ct.Indexed;
                if (iIndexed < m_colors.Length)
                    strColor = m_colors[iIndexed];
            }

            // ȡɫַ
            if (strColor.Length == 0)
            {
                return "";
            }
            else if (strColor.Length > 6)
            {
                strColor = strColor.Substring(strColor.Length - 6, 6);
            }

            // ʵɫ
            if (ct.Tint != null && ct.Tint != 0.0f)
            {
                int iColor = Convert.ToInt32(strColor, 16);   //strColor.hex_to_dec();
                int iRed = (iColor >> 16) & 0xff;
                iRed = calc_single_tinted_value(iRed, ct.Tint);
                int iGreen = (iColor >> 8) & 0xff;
                iGreen = calc_single_tinted_value(iGreen, ct.Tint);
                int iBlue = (iColor) & 0xff;
                iBlue = calc_single_tinted_value(iBlue, ct.Tint);
                iColor = (iRed << 16) + (iGreen << 8) + iBlue;
                strColor = string.Format("{0:X}",iColor);
                while (strColor.Length < 6)
                    strColor = "0" + strColor;
            }

            // ɽɫַ
            if (strColor.Length > 6)
                strColor = strColor.Substring(strColor.Length - 6, 6);
            while (strColor.Length < 8)
                strColor = "F" + strColor;
            return strColor;
        }

        /// <summary>
        /// ȡԪ񱳾ɫ
        /// </summary>
        /// <param name="cell">Ԫ</param>
        /// <returns>Ԫ񱳾ɫ</returns>
        public String get_background_color(Cell cell)
        {
            // ȡ
            int cellStyleIndex = 0;
            if (cell.StyleIndex != null)
                cellStyleIndex = (int)cell.StyleIndex.Value;
            CellFormat cf = (CellFormat)m_styles.Stylesheet.CellFormats.ChildElements[cellStyleIndex];
            Fill fill = (Fill)m_styles.Stylesheet.Fills.ChildElements[(int)cf.FillId.Value];
            return format_color(fill.PatternFill.ForegroundColor);
        }

        /// <summary>
        /// ȡԪǰɫ
        /// </summary>
        /// <param name="cell">Ԫ</param>
        /// <returns>Ԫǰɫ</returns>
        public String get_foreground_color(Cell cell)
        {
            // ȡ
            int cellStyleIndex = 0;
            if (cell.StyleIndex != null)
                cellStyleIndex = (int)cell.StyleIndex.Value;
            CellFormat cf = (CellFormat)m_styles.Stylesheet.CellFormats.ChildElements[cellStyleIndex];
            Font font = (Font)m_styles.Stylesheet.Fonts.ChildElements[(int)cf.FontId.Value];
            return format_color(font.Color);
        }

        /// <summary>
        /// ȡԪɫ
        /// </summary>
        /// <param name="strForeColor">ǰɫ</param>
        /// <param name="strBackColor">ɫ</param>
        /// <returns>Ԫɫ</returns>
        private int get_cell_format_index(String strForeColor, String strBackColor, int iDefault = 0)
        {
            // бǷ
            OpenXmlElementList list = m_styles.Stylesheet.CellFormats.ChildElements;
            OpenXmlElementList tlist = m_styles.Stylesheet.Fonts.ChildElements;
            CellFormat cf = null;
            for (int i = 0; i < list.Count; ++i)
            {
                cf = (CellFormat)list[i];
                String strTmpForeColor = format_color(((Font)tlist[(int)cf.FontId.Value]).Color);
                String strTmpBackColor = format_color(((Fill)tlist[(int)cf.FillId.Value]).PatternFill.ForegroundColor);
                if (strTmpForeColor == strForeColor || strTmpBackColor == strBackColor)
                    return i;
            }

            return iDefault;
        }
    }
}