﻿using OfficeOpenXml;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Autogen_WS
{
    public class WeightInfo
    {
        public List<PLCGroup.Weight> weights = new List<PLCGroup.Weight>();

        /// <summary>
        /// 读取设备转换表
        /// </summary>
        /// <returns></returns>
        public bool Load(string xlsxfile)
        {
            weights.Clear();


            int i_name = 1;//层名称
            int i_bincnt = 2;//料仓数量


            using (ExcelPackage packages = new ExcelPackage(new FileInfo(xlsxfile)))
            {
                using (ExcelWorksheet sheet = packages.Workbook.Worksheets["各层料仓数"])
                {
                    int iRow = 2;
                    int i = iRow - 1;
                    while (true)
                    {
                        i++;
                        string str_name;
                        string str_bincnt;
                        try
                        {
                            str_name = sheet.Cells[i, i_name].Value.ToString();
                            str_bincnt = sheet.Cells[i, i_bincnt].Value.ToString();
                        }
                        catch
                        {
                            //完成，没有数据了
                            break;
                        }

                        if (string.IsNullOrEmpty(str_name)) break;

                        weights.Add(
                            new PLCGroup.Weight() { Name = str_name, BinCnt = int.Parse(str_bincnt) }
                            );

                    }
                }
            }
            if (weights.Count == 0)
                return false;
            return true;
        }
    }
}
